image: node:lts

stages:
  - storybook
  - lint-tests
  - build
  - deploy

# storybook stage
storybook:build:
  stage: storybook
  only:
    - merge_requests
    - master
  script:
    - PUPPETEER_SKIP_CHROMIUM_DOWNLOAD=true yarn
    - yarn build-storybook
  artifacts:
    expire_in: 1 week
    name: 'n7-picross-storybook-${CI_COMMIT_REF_SLUG}'
    paths:
      - storybook-static

# lint & test stage
quality:
  image: buildkite/puppeteer
  stage: lint-tests
  only:
    - merge_requests
    - master
  script:
    - yarn
    - yarn lint
    - yarn test:unit -- --coverage --reporters=default
  dependencies:
    - storybook:build
  coverage: /All files[^|]*\|[^|]*\s+([\d\.]+)/
  artifacts:
    expire_in: 1 week
    name: 'n7-picross-snapshots-${CI_COMMIT_REF_SLUG}'
    when: always
    paths:
    - tests/unit/__image_snapshots__
    reports:
      junit:
        - junit.xml

# e2e:
#   image: cypress/base:10
#   stage: lint-tests
#   when: manual
#   script:
#     - yarn
#     - $(npm bin)/cypress cache path
#     - $(npm bin)/cypress cache list
#     - $(npm bin)/cypress verify
#     - $(npm bin)/cypress run
#   artifacts:
#     expire_in: 1 week
#     when: always
#     paths:
#     - cypress/screenshots
#     - cypress/videos

# Build stage
build:
  stage: build
  only:
    - tags
    - merge_requests
    - master
  script:
    - PUPPETEER_SKIP_CHROMIUM_DOWNLOAD=true yarn
    - yarn build
  artifacts:
    expire_in: 3 mos
    name: 'n7-picross-${CI_COMMIT_REF_SLUG}'
    paths:
    - dist/

# Deploy stage
deploy-n7-picross-mda:
  dependencies:
    - build
  stage: deploy
  when: manual
  script:
    - npx surge dist n7-picross-mda.surge.sh
  environment:
    name: review/n7-picross-mda
    url: http://n7-picross-mda.surge.sh
    on_stop: teardown-n7-picross-mda

deploy-storybook:
  dependencies:
    - storybook:build
  stage: deploy
  when: manual
  script:
    - npx surge storybook-static n7-picross-mda-storybook.surge.sh
  environment:
    name: review/n7-picross-mda-storybook
    url: http://n7-picross-mda-storybook.surge.sh
    on_stop: teardown-storybook

teardown-n7-picross-mda:
  stage: deploy
  variables:
    GIT_STRATEGY: none
  script:
    - npx surge teardown n7-picross-mda.surge.sh
  when: manual
  environment:
    name: review/n7-picross-mda
    url: http://n7-picross-mda.surge.sh
    action: stop

teardown-storybook:
  stage: deploy
  variables:
    GIT_STRATEGY: none
  script:
    - npx surge teardown n7-picross-mda-storybook.surge.sh
  when: manual
  environment:
    name: review/n7-picross-mda-storybook
    url: http://n7-picross-mda-storybook.surge.sh
    action: stop
